----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:40:48 04/08/2015 
-- Design Name: 
-- Module Name:    extract_key - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity extract_key is
	port (
		key_in : in std_logic_vector(79 downto 0);
		i		   : in std_logic_vector(4 downto 0);
		rk		 : out std_logic_vector(31 downto 0)
	);
end extract_key;

architecture Behavioral of extract_key is

	component sbox is
		port(
			nibble_in : in std_logic_vector(3 downto 0);
			nibble_out: out std_logic_vector(3 downto 0)
		);
	end component;

	signal Z 	: std_logic_vector(31 downto 0);
	signal rk_s : std_logic_vector(31 downto 0);

begin

  Z(3 downto 0)   <= key_in(64) & key_in(40) & key_in(24) & key_in(4);
  Z(7 downto 4)   <= key_in(65) & key_in(41) & key_in(25) & key_in(5);
  Z(11 downto 8)  <= key_in(66) & key_in(42) & key_in(26) & key_in(6);
  Z(15 downto 12) <= key_in(67) & key_in(43) & key_in(27) & key_in(7);
  Z(19 downto 16) <= key_in(72) & key_in(52) & key_in(36) & key_in(12);
  Z(23 downto 20) <= key_in(73) & key_in(53) & key_in(37) & key_in(13);
  Z(27 downto 24) <= key_in(74) & key_in(54) & key_in(38) & key_in(14);
  Z(31 downto 28) <= key_in(75) & key_in(55) & key_in(39) & key_in(15);

	sbox_0 : sbox port map (
    nibble_in	=>	Z(31 downto 28),
    nibble_out	=> rk_s(3 downto 0)
  );
  
  sbox_1 : sbox port map (
    nibble_in	=>	Z(27 downto 24),
    nibble_out	=> rk_s(7 downto 4)
  );
  
  sbox_2 : sbox port map (
    nibble_in	=>	Z(23 downto 20),
    nibble_out	=> rk_s(11 downto 8)
  );
  
  sbox_3 : sbox port map (
    nibble_in	=>	Z(19 downto 16),
    nibble_out	=> rk_s(15 downto 12)
  );
	
	sbox_4 : sbox port map (
    nibble_in	=>	Z(15 downto 12),
    nibble_out	=> rk_s(19 downto 16)
  );
  
  sbox_5 : sbox port map (
    nibble_in	=>	Z(11 downto 8),
    nibble_out	=> rk_s(23 downto 20)
  );
  
  sbox_6 : sbox port map (
    nibble_in	=>	Z(7 downto 4),
    nibble_out	=> rk_s(27 downto 24)
  );
  
  sbox_7 : sbox port map (
    nibble_in	=>	Z(3 downto 0),
    nibble_out	=> rk_s(31 downto 28)
  );

	rk(31 downto 8) <= rk_s(31 downto 8);
  rk(7) <= rk_s(7) xor i(0);
  rk(6 downto 4) <= rk_s(6 downto 4);
	rk(3 downto 0) <= rk_s(3 downto 0) xor i(4 downto 1);

end Behavioral;

