----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:46:43 04/08/2015 
-- Design Name: 
-- Module Name:    permutation_layer - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity permutation_layer is
	port (
		mode_i	: in std_logic;
		state_i	: in std_logic_vector(63 downto 0);
		state_o	: out std_logic_vector(63 downto 0)
	);
end permutation_layer;

architecture Behavioral of permutation_layer is

begin
	with mode_i select
		state_o(3 downto 0) <= 
			state_i(59 downto 56) when '0',
			state_i(55 downto 52) when others;
			
	with mode_i select
		state_o(7 downto 4) <= 
			state_i(47 downto 44) when '0',
			state_i(39 downto 36) when others;
			
	with mode_i select
		state_o(11 downto 8) <= 
			state_i(51 downto 48) when '0',
			state_i(59 downto 56) when others;
			
	with mode_i select
		state_o(15 downto 12) <= 
			state_i(43 downto 40) when '0',
			state_i(35 downto 32) when others;
			
	with mode_i select
		state_o(19 downto 16) <= 
			state_i(35 downto 32) when '0',
			state_i(43 downto 40) when others;
			
	with mode_i select
		state_o(23 downto 20) <= 
			state_i(39 downto 36) when '0',
			state_i(47 downto 44) when others;
			
	with mode_i select
		state_o(27 downto 24) <= 
			state_i(55 downto 52) when '0',
			state_i(51 downto 48) when others;
			
	state_o(31 downto 28) <= state_i(63 downto 60);
			
	with mode_i select
		state_o(35 downto 32) <= 
			state_i(15 downto 12) when '0',
			state_i(19 downto 16) when others;
			
	with mode_i select
		state_o(39 downto 36) <= 
			state_i(7 downto 4) when '0',
			state_i(23 downto 20) when others;
			
	with mode_i select
		state_o(43 downto 40) <= 
			state_i(19 downto 16) when '0',
			state_i(15 downto 12) when others;
			
	with mode_i select
		state_o(47 downto 44) <= 
			state_i(23 downto 20) when '0',
			state_i(7 downto 4) when others;
			
	with mode_i select
		state_o(51 downto 48) <= 
			state_i(27 downto 24) when '0',
			state_i(11 downto 8) when others;
			
	with mode_i select
		state_o(55 downto 52) <= 
			state_i(3 downto 0) when '0',
			state_i(27 downto 24) when others;
			
	with mode_i select
		state_o(59 downto 56) <= 
			state_i(11 downto 8) when '0',
			state_i(3 downto 0) when others;
			
	state_o(63 downto 60) <= state_i(31 downto 28);
	
end Behavioral;